package com.base.datarecovery.fragment

import android.animation.AnimatorSet
import android.animation.ObjectAnimator
import android.annotation.SuppressLint
import android.content.Intent
import android.view.View
import android.view.animation.AccelerateDecelerateInterpolator
import com.base.datarecovery.activity.FileScanActivity
import com.base.datarecovery.activity.PrivacySpaceActivity
import com.base.datarecovery.ads.AdmobNativeUtils
import com.base.datarecovery.bean.ConstObject.SCAN_DOCUMENTS
import com.base.datarecovery.bean.ConstObject.SCAN_PHOTOS
import com.base.datarecovery.bean.ConstObject.SCAN_VIDEOS
import com.base.datarecovery.databinding.FragmentHomeBinding
import com.base.datarecovery.help.BaseFragment

class HomeFragment : BaseFragment<FragmentHomeBinding>() {

    override val binding: FragmentHomeBinding by lazy {
        FragmentHomeBinding.inflate(layoutInflater)
    }
    private lateinit var animatorSet: AnimatorSet

    override fun setView() {
        animatorSet = createHeartbeatAnimation(binding.flScan)
        AdmobNativeUtils.showNativeAd(requireActivity(), binding.flAd)
    }

    override fun setListener() {

        binding.flRyPhoto.setOnClickListener {
            startActivity(Intent(requireContext(), FileScanActivity::class.java).apply {
                putExtra("Type", SCAN_PHOTOS)
            })
        }
        binding.flRyVideo.setOnClickListener {
            startActivity(Intent(requireContext(), FileScanActivity::class.java).apply {
                putExtra("Type", SCAN_VIDEOS)
            })
        }
        binding.cardRyDocument.setOnClickListener {
            startActivity(Intent(requireContext(), FileScanActivity::class.java).apply {
                putExtra("Type", SCAN_DOCUMENTS)
            })
        }
        binding.cardPrivacySpace.setOnClickListener {
            startActivity(Intent(requireContext(), PrivacySpaceActivity::class.java).apply {

            })
        }


    }

    @SuppressLint("Recycle")
    fun createHeartbeatAnimation(view: View): AnimatorSet {
        // 创建放大动画
        val scaleUpAnimator = ObjectAnimator.ofFloat(view, "scaleX", 1f, 1.1f)
        scaleUpAnimator.setDuration(500)
        scaleUpAnimator.interpolator = AccelerateDecelerateInterpolator()
        scaleUpAnimator.repeatCount = ObjectAnimator.INFINITE
        scaleUpAnimator.repeatMode = ObjectAnimator.REVERSE

        // 创建缩小动画
        val scaleDownAnimator = ObjectAnimator.ofFloat(view, "scaleY", 1.1f, 1f)
        scaleDownAnimator.setDuration(500)
        scaleDownAnimator.interpolator = AccelerateDecelerateInterpolator()
        scaleDownAnimator.setStartDelay(500) // 延迟开始，以便与放大动画同步结束
        scaleDownAnimator.repeatCount = ObjectAnimator.INFINITE
        scaleDownAnimator.repeatMode = ObjectAnimator.REVERSE

        // 组合放大和缩小动画
        val animatorSet = AnimatorSet()
        animatorSet.play(scaleUpAnimator).with(scaleDownAnimator)

        // 启动动画
        animatorSet.start()
        return animatorSet
    }

    override fun onPause() {
        super.onPause()
        animatorSet.pause()
    }

    override fun onResume() {
        super.onResume()
        animatorSet.resume()
    }

}